// DXF to POV converter (version 0.81) : Display module
// Coded by Richard Dorman (March-April 1994)

// For the moment this is included directly into the DXF2POV module.
// So no prototypes.

void Adjust(float &scale,float &ax, float &ay) {
  float sx,sy;

  if (PolyLine.max.x != PolyLine.min.x)
    sx = 600.0/(PolyLine.max.x-PolyLine.min.x);
  else
    sx = 1;
  if (PolyLine.max.y != PolyLine.min.y)
    sy = 440.0/(PolyLine.max.y-PolyLine.min.y);
  else
    sy = 1;
  scale = sx<sy ? sx : sy;
  ax = -scale*PolyLine.min.x;
  ay = -scale*PolyLine.min.y;
}


void DrawNormals(int Vertex_Count,float sc,float ax,float ay) {
  int i;

  setcolor(BLUE);
  for(i=1;i<Vertex_Count;i++)
    line(Mesh[i].x*sc+ax,Mesh[i].y*sc+ay,
	 (Mesh[i].x+Normals[i].x)*sc+ax,(Mesh[i].y+Normals[i].y)*sc+ay);
}


void DrawPolyfaceMesh(int Vertex_Count,int Face_Count) {
  int i,j; float sc,ax,ay;

  Adjust(sc,ax,ay);
  //clearviewport();

  setcolor(WHITE);
  for(i=0;i<Face_Count;i++)
    for(j=0;j<VCount[i];j++) {
      if(Faces[i][j] < 0) setcolor(GREEN); else setcolor(WHITE);
      line(Mesh[abs(Faces[i][j])].x*sc+ax,Mesh[abs(Faces[i][j])].y*sc+ay,
	   Mesh[abs(Faces[i][(j+1)%VCount[i]])].x*sc+ax,Mesh[abs(Faces[i][(j+1)%VCount[i]])].y*sc+ay);
    }

  if (SmoothTriangles) DrawNormals(Vertex_Count,sc,ax,ay);
}

void DrawPolygonMesh(int Vertex_Count,int M,int N,int M_wrap,int N_wrap) {
  int i,j; float sc,ax,ay;

  Adjust(sc,ax,ay);
  //clearviewport();

  setcolor(WHITE);
  for (i=0;i<N+N_wrap;i++)
    for (j=1;j<M+M_wrap;j++)
      line(Mesh[(j%M)*N+(i%N)+1].x*sc+ax,
	   Mesh[(j%M)*N+(i%N)+1].y*sc+ay,
	   Mesh[((j-1)%M)*N+(i%N)+1].x*sc+ax,
	   Mesh[((j-1)%M)*N+(i%N)+1].y*sc+ay);
  for (i=0;i<M+M_wrap;i++)
    for (j=1;j<N+N_wrap;j++)
      line(Mesh[(i%M)*N+(j%N)+1].x*sc+ax,
	   Mesh[(i%M)*N+(j%N)+1].y*sc+ay,
	   Mesh[(i%M)*N+(j-1)%N+1].x*sc+ax,
	   Mesh[(i%M)*N+(j-1)%N+1].y*sc+ay);

  if (SmoothTriangles) DrawNormals(Vertex_Count,sc,ax,ay);
}

