// DXF to POV converter (version 0.81) : Tools module
// Coded by Richard Dorman (March-April 1994)

#include "dxf-pov.h"

/* ---------------------------------------------------------------------- */

// A special type that can read entire lines including whitespace.

istream& operator >> (istream& s, Group_Type& m) {
  char chr; int count;

  if (m.lastread)
    m.lastread = FALSE;
  else {
    // Inc line number
    m.line++; m.line++;

    // Get code
    In >> m.code; s.get(chr);

    // Get value (depends on code)

    count = 0; s.get(chr);
    while (chr != '\n' && chr != EOF) {
      if (count == 256)
	{cout << "Line [" << m.line << "] Error in input file : Maximum line length exceded.\n"; exit(1); }
	m.value[count] = chr;
	s.get(chr); count++;
      }
    m.value[count] = '\x0';
  }

  return s;
}

void Assign(char *Value, Group_Type &Group) {
  strcpy(Value,Group.value);
}

void Assign(float &Value, Group_Type &Group) {
  Value = atof(Group.value);
}

void Assign(int &Value, Group_Type &Group) {
  Value = atoi(Group.value);
}

/* ---------------------------------------------------------------------- */

// Vector operators.

point ZeroVector = {0,0,0};
point XUnit      = {1,0,0};
point YUnit      = {0,1,0};
point ZUnit      = {0,0,1};
point MinVector  = {MINFLOAT,MINFLOAT,MINFLOAT};
point MaxVector  = {MAXFLOAT,MAXFLOAT,MAXFLOAT};

point Unit(point p)
  // Find the unit vector of vector v
  {
    float mag=Magnitude(p);
    if (mag != 0)
      { p.x=p.x/mag;
	p.y=p.y/mag;
	p.z=p.z/mag;
      }
    else p=ZeroVector;
    return p;
  };

int operator == (point p1, point p2) {
  if (p1.x != p2.x) return 0; else
  if (p1.y != p2.y) return 0; else
  if (p1.z != p2.z) return 0; else
  return 1;
}

point operator +(point p1,point p2) {
  point p;
  p.x = p1.x+p2.x;
  p.y = p1.y+p2.y;
  p.z = p1.z+p2.z;
  return p;
}

point operator -(point p1,point p2) {
  point p;
  p.x = p1.x-p2.x;
  p.y = p1.y-p2.y;
  p.z = p1.z-p2.z;
  return p;
}

point operator *(point p1,point p2) {
  point p;
  p.x = p1.y*p2.z-p2.y*p1.z;
  p.y = p1.z*p2.x-p2.z*p1.x;
  p.z = p1.x*p2.y-p2.x*p1.y;
  return p;
}

point operator *(float a,point p1) {
  point p;
  p.x = p1.x*a;
  p.y = p1.y*a;
  p.z = p1.z*a;
  return p;
}
